/*
                           Copyright (C) 1995 
             John R.Callahan, Sudhakar Ramakrishnan, Sun Wei.
	         Web Integrated Software Project 
                   Management and Metrics Tool
                           (WISE)

WISE [both binary and source] (hereafter, Software) is 
copyrighted by John R.Callahan, Sudhakar Ramakrishnan , Sun Wei and 
ownership remains with the authors.

The authors grant you (hereafter, Licensee), a license to use the Software
for academic, research and internal business purposes only, without a
fee.  Licensee may distribute the binary to third parties providing 
that the copyright notice and this statement appears on all copies and
that no charge is associated with such copies. 

Licensee may make derivative works.  However, if Licensee distributes
any derivative work based on or derived from the Software, then
Licensee will (1) notify the authors regarding its distribution of 
the derivative work, and (2) clearly notify users that such derivative 
work is a modified version and not the original WISE tool distributed 
by the authors.

Any Licensee wishing to make commercial use of the Software should
contact the authors to negotiate an appropriate license for such
commercial use.  Commercial use includes (1) integration of all or
part of the source code into a product for sale or license by or on
behalf of licensee to third parties, or (2) distribution of the binary
code or source code to third parties that need it to utilize a
commercial product sold or licensed by or on behalf of Licensee.

THE AUTHORS MAKE NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS 
SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
IMPLIED WARRANTY.  THE AUTHORS SHALL NOT BE LIABLE FOR ANY DAMAGES
SUFFERED BY USERS OF THIS SOFTWARE.

By using or copying this Software, Licensee agrees to abide by the
copyright law and all other applicable laws of the U.S., including but
not limited, to, export control laws, and the terms of this license.
The authors shall have the right to terminate this license immediately by
written notice upon Licensee's breach of, or non-compliance with, any
of its terms.  Licensee may be held legally responsible for any
copyright infringement that is caused, directly or indirectly, by
Licensee's failure to abide by the terms of this license.

Direct notices to:
	
	John R.Callahan 
	886 Chestnut Ridge Road
	Concurrent Engineering Research Center
	West Virginia University
	Morgantown, WV 26505
	USA

	phone:	(304) 293-7226
	email:	callahan@cerc.wvu.edu
*/
#define WISEMAIN
#include <stdio.h>
#include <stdlib.h>
#include "msql.h"
#include "cgi.h"
#include "wise.h"

struct sortentry_t {
  char* fieldname;
  int order;
  struct sortentry_t* next;
};
typedef struct sortentry_t sortentry;
sortentry* sorthead = NULL;

char orderby[WISEBUFMAX];

void
sortby(char* field,int direction)
{
  sortentry* p;
  if(sorthead == NULL) {
    sorthead = (sortentry*)malloc(sizeof(sortentry));
    sorthead->fieldname = field;
    sorthead->order = direction;
    sorthead->next = NULL;
  } else {
    for(p=sorthead;p->next != NULL;p=p->next);
    p->next = (sortentry*)malloc(sizeof(sortentry));
    p = p->next;
    p->fieldname = field;
    p->order = direction;
    p->next = NULL;
  }
  return;
}

int
sorted(char* field)
{
  int i=1;
  sortentry* p;

  for(p=sorthead;p != NULL;p=p->next) {
    if(strcmp(field,p->fieldname) == 0) return p->order*i;
    i++;
  }
  return 0;
}

void
dosortvector(char* except)
{
  sortentry *p;

  for(p=sorthead;p != NULL;p=p->next) {
    if(except == NULL || strcmp(p->fieldname,except) != 0) {
      if(p->order < 0) printf("<INPUT TYPE=hidden NAME=descend VALUE=%s>\n",p->fieldname);
      else if(p->order > 0) printf("<INPUT TYPE=hidden NAME=ascend VALUE=%s>\n",p->fieldname);
    }
  }
}


void
sql_select(char* ru, char* project, char* issueno, form_entry *parms)
{
  int i,j,nr,nf,sock;
  m_result *result;
  m_row row;
  char buf[512];
  char* db;
  char* dbhost;

  if((dbhost = wise_getprojhost(project)) == NULL) {
    printf("<H1>Could not find project %s database host!</H1>",project);
    return;
  }
  wise_setprojport(project);
  if((sock = msqlConnect(dbhost)) < 0) {
    printf("<H1>Connect error: %s</H1>",msqlErrMsg);
    return;
  }
  if((db = wise_getprojdb(project)) == NULL) {
    printf("<H1>Could not get project's database name!</H1>");
    return;
  }
  if(msqlSelectDB(sock,db) < 0) {
    printf("<H1>WISE server currently unavailable<H1>");
    printf("<H2>Please try again later</H2>");
    return;
  }
  sprintf(buf,"select * from %s where issueno = %s",project,issueno);
  if(WISEDEBUG) printf("query = %s\n",buf);
  if(msqlQuery(sock,buf) < 0) {
    printf("<H1>Query error: %s</H1>",msqlErrMsg);
    return;
  }
  result = msqlStoreResult();
  if((row = msqlFetchRow(result)) == NULL) {
    printf("<H1>Fetch error: %s</H1>",buf);
    return;
  }
  printf("<center><H2>ISSUE NUMBER: %s</H2><BR>\n",issueno);
  printf("<FORM ACTION=\"http://%s:%s/%s\" METHOD=POST>\n",WISEHOST,
	 WISEPORT,WISE_UPDATE);
  printf("<table border=1 cellpadding=2>\n");
  printf("<TD>Issue Number<TD>R<TD>%s<TR>\n",row[0]);
  printf("<INPUT TYPE=hidden NAME=issueno VALUE=\"%s\">\n",issueno);
  printf("<TD>Project<TD>R<TD>%s<TR>",row[1]);
  printf("<INPUT TYPE=hidden NAME=project VALUE=\"%s\">\n",project);
  dosortvector(NULL);

#ifdef NEWREPORT
  wise_print_hidden_opts (project, parms); 
#endif /* NEWREPORT */

  printf("<TD>Role(s)<TD>R<TD>%s<TR>\n",wise_getroles(ru,project));
  nr = 2;
  nf = wise_numoffields(project);
  for(i=0;i < nf;i++) {
    wise_printfield(sock,ru,project,issueno,i,&nr,row);
  }
  printf("</table>\n");
  wise_printactions(ru,row[0],row[1]);
  printf("</FORM></center>\n");
  msqlFreeResult(result);
  msqlClose(sock);
}

int
main()
{
  char* ru;
  cgi_info ci;
  int status = 0;
  char* project = NULL;
  char* issueno = NULL;
  form_entry *parms, *p;

  /* display MIME header */
  printf("Content-type: text/html\n\n");

  /* get the name of the remote user */
  if((ru = getenv("REMOTE_USER")) == NULL) {
    printf("<H1>Error: cannot get remote user name</H1>");
    return 0;
  }

  /* load command line parameters */
  status = get_cgi_info( &ci );  
  if (!status) {
    printf("<h1>Error: Processing CGI info</h1>");
    return 0;
  }
/*
ci.query_string = "project=linusfu&issueno=1";
ci.request_method="POST";
*/

  /* display the record */
  parms = get_form_entries(&ci);
  p = parms;
  while(parms) {
    if(WISEDEBUG) printf("name,val: %s,%s<BR>\n",parms->name,parms->val);
    if(strlen(parms->name) > WISEBUFMAX || strlen(parms->val) > WISEBUFMAX) {
      printf("<h1>Error: Submission strings too long.  Try again...</h1>");
      return 0;
    }
    if(strcmp(parms->name,"ascend") == 0) {
      sortby(parms->val,1);
    } else if(strcmp(parms->name,"descend") == 0) {
      sortby(parms->val,-1);
    } else if(strcmp(parms->name,"project")==0) {
      project=parms->val;
    } else if(strcmp(parms->name,"issueno")==0) {
      issueno=parms->val;
    }
    parms=parms->next;
  }
  parms = p;

  /* define and display the HTML page */
  printf("<!DOCTYPE DOCTYPE HTML SYSTEM \"html.dtd\">\n\
         <HTML>\n\
         <HEAD>\n\
         <TITLE>%s Issue Number %s</TITLE>\n\
         </HEAD>\n\
         \n\
         <BODY  background=\"%s\"\
         text=\"000000\" link=\"0000ff\"\
         vlink=\"0000ff\">\n\
         \n\
         <BASEFONT SIZE=4>\n\
         \n\
         <P>\n",project,issueno,WISEBKGND);

  if(WISEDEBUG) printf("project,issueno:");
  if(project != NULL && issueno != NULL) {
    if(WISEDEBUG) printf("%s, %s<BR>\n",project,issueno);
    sql_select(ru,project,issueno, parms);
  }

  free_form_entries(parms);

  return 0;
}
